Add an insert operation to the bulk

- « MongoDB\Driver\BulkWrite::delete

- MongoDB\Driver\BulkWrite::update »

- PHP Manual
- MongoDB\Driver\BulkWrite
- Add an insert operation to the bulk

# MongoDB\Driver\BulkWrite::insert

(mongodb >=1.0.0)

MongoDB\Driver\BulkWrite::insert — Add an insert operation to the bulk

### Description

public MongoDB\Driver\BulkWrite::insert(array|object `$document`): mixed

Adds an insert operation to the MongoDB\Driver\BulkWrite.

### Parameters

`document` (array|object)

  A document to insert.

### Return Values

Returns the `_id` of the inserted document. If the `document` did not have an `_id`, the MongoDB\BSON\ObjectId generated for the insert will be returned.

### Errors/Exceptions

- Throws MongoDB\Driver\Exception\InvalidArgumentException on argument parsing errors.

### Changelog

Version | Description
--- | ---
PECL mongodb 1.3.0 | The `_id` of the inserted document is always returned. Previously, the method only returned a value if a MongoDB\BSON\ObjectId was generated.

### Examples

Example #1 MongoDB\Driver\BulkWrite::insert() example

    <?php$bulk = new MongoDB\Driver\BulkWrite;$document1 = ['title' => 'one'];$document2 = ['_id' => 'custom ID', 'title' => 'two'];$document3 = ['_id' => new MongoDB\BSON\ObjectId, 'title' => 'three'];$_id1 = $bulk->insert($document1);$_id2 = $bulk->insert($document2);$_id3 = $bulk->insert($document3);var_dump($_id1, $_id2, $_id3);$manager = new MongoDB\Driver\Manager('mongodb://localhost:27017');$result = $manager->executeBulkWrite('db.collection', $bulk);?>

The above example will output something similar to:

    object(MongoDB\BSON\ObjectId)#3 (1) {
      ["oid"]=>
      string(24) "54d51146bd21b91405401d92"
    }
    NULL
    NULL

### See Also

- MongoDB\Driver\Manager::executeBulkWrite() - Execute one or more write operations
- MongoDB\Driver\WriteResult
- MongoDB\BSON\ObjectId
- MongoDB\BSON\Persistable